/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef AUTOMOUNT_H
#define AUTOMOUNT_H

#include <gtkmm.h>
#include "Pline/MountPline.h"

class VolumeGui;
class VolumeMountGui;
class DispatchData;

class Automount
{
public:
	Automount(	std::list<VolumeGui*>& lstVolumeGui,
				Glib::Mutex& omtxVolumeGuiLst);
	~Automount();

	void start();
	void stop();

protected:

private:
	std::list<VolumeGui*>& 		glstVolumeGuiAct;
	Glib::Mutex& 				gomtxVolumeGuiLstAct;
	
	bool gbStop;
	std::list<VolumeGui*> glstVolumeGui;
	
	void getVolumes(std::vector<VolumeGui*> *pvecToMount, 
					std::vector<VolumeGui*> *pvecToMountErr);
	
	bool isVolumeGuiFound(VolumeGui* poVolumeGui);
	
	void onMounted(bool bSuccess, VolumeMountGui* poVolumeGui);
};
	
#endif /* AUTOMOUNT_H */
