/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "CloneData.h"
#include "QDebug.h"

namespace Pline
{

//==============================================================================

CloneData::CloneData(const Data &oData)
: Data(oData)
{
	init();
}

//==============================================================================

CloneData::~CloneData()
{
}

//==============================================================================

CloneData* CloneData::operator=(const CloneData &oCloneData)
{
	gstDest = oCloneData.gstDest;
	gbCanOverwrite = oCloneData.gbCanOverwrite;
	
	return this;
}

//==============================================================================

bool CloneData::operator==(const CloneData &oCloneData) const
{	
	if (gstDest == oCloneData.gstDest
		&& gbCanOverwrite == oCloneData.gbCanOverwrite)
	{
		return true;
	}
	
	return false;
}

//==============================================================================

bool CloneData::operator!=(const CloneData &oCloneData) const
{	
	return !((*this).operator==(oCloneData));
}

//==============================================================================

void CloneData::init()
{
	gbCanOverwrite = false;
}

//==============================================================================

} // Pline
