/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef FSYSUTIL_H
#define FSYSUTIL_H

#include <gtkmm.h>
#include <vector>

namespace Pline 
{

class FSysUtil
{
public:
	FSysUtil();
	~FSysUtil();

	static void getMkFSysList(std::vector<Glib::ustring> *pvecFSys);
	static void getEnlargeFSysList(std::vector<Glib::ustring> *pvecFSys);
	
	// xfs filesystem needs stDir and device must be mounted
	static bool enlarge(const Glib::ustring& stDev,
						const Glib::ustring& stDir,
						const Glib::ustring& stFSys,
						Glib::ustring *pstErrMsg = 0);
						
	static bool format(	const Glib::ustring& stDev,
						const Glib::ustring& stVolumeLabel,
						const Glib::ustring& stFSys,
						Glib::ustring *pstErrMsg = 0);
					
protected:

private:
	static bool enlarge_ext(const Glib::ustring& stDev,
							Glib::ustring *pstErrMsg = 0);
	static bool enlarge_raiserfs(	const Glib::ustring& stDev,
									Glib::ustring *pstErrMsg = 0);
	static bool enlarge_xfs(const Glib::ustring& stDir,
							Glib::ustring *pstErrMsg = 0);
	
	static const Glib::ustring getEscapedVolumeLabel(const Glib::ustring& stVolumeLabel);
	static bool getMkFSysArg(	const Glib::ustring& stFSys,
								Glib::ustring *pstArg);
	static bool getMkFSysCommand(	const Glib::ustring& stFSys,
									Glib::ustring *pstCmd);
};

} // Pline
#endif /* FSYSUTIL_H */
