/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LOOPFILTER_H
#define LOOPFILTER_H

#include "MountBaseFilter.h"
#include "LoopData.h"

#include <gtkmm.h>

namespace Pline
{

class LoopFilter : public MountBaseFilter
{
public:
	LoopFilter();
	virtual ~LoopFilter();
	
	// ready to enter data
	void askData();

	// filter config
	inline const Glib::ustring getFilterName() const {return "Loop";}

	// data
	void setSrcData(LoopData *poData);
	void setDestData(Data *poData);
	
	// run
	bool isAttached();
		
protected:
	bool probe();
	bool attach();
	bool detach();

private:
	LoopData *gpoLoopData;
};

} // Pline	
#endif /* LOOPFILTER_H */
