/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LOOPUTIL_H
#define LOOPUTIL_H

#include <gtkmm.h>
#include <vector>

namespace Pline
{

class LoopUtil
{
public:
	LoopUtil();
	~LoopUtil();

	static bool createDev(Glib::ustring *pstDev);
	static bool detachDev(  const Glib::ustring& stDev,
							Glib::ustring* pstErrMsg = 0);
	static bool findDev(const Glib::ustring& stSrc,
						Glib::ustring *pstDev = 0);
	static bool findUnusedDev(Glib::ustring *pstDev = 0);
	static bool setLoop(const Glib::ustring& wxstDev, 
						const Glib::ustring& wxstSrc,
						bool *bReadOnly,
						Glib::ustring* pstErrMsg = 0);
	
	// validate
	static bool isValidSrc( const Glib::ustring& stSrc, 
							Glib::ustring* pstErrMsg = 0);
	static bool isValidDev( const Glib::ustring& stDev, 
							Glib::ustring* pstErrMsg = 0);
	
protected:

private:
	static void buildDevLoopList( std::vector<Glib::ustring> *pvecLoop);
	static void getDevLoopList(std::vector<Glib::ustring> *pvecLoop);
};

} // Pline	
#endif // LOOPUTIL_H
