/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PROCESSBASEPLINE_H
#define PROCESSBASEPLINE_H

#include "Pline.h"

#include <gtkmm.h>

namespace Pline
{

class ProcessBaseFilter;

class ProcessBasePline : public Pline
{
public:
	ProcessBasePline(	const eDataMode eDataModeItem,
						VolumeConfig *poVolumeConfig);
	~ProcessBasePline();

	// cancel operations
	inline bool isCanCancel() {return gbCanCancel;}
	bool cancel();

	// status
	virtual const Glib::ustring getInfoMessage() = 0;
	virtual const int getPctDone() = 0;
	
protected:
	virtual void onCanCancelChanged(bool b);
	virtual bool onFilterPreRun(Filter *poFilter);
	
private:
	ProcessBaseFilter *gpoRunningFilter;
	bool gbCanCancel;
};

} // Pline	
#endif /* PROCESSBASEPLINE_H */
