/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef QDIALOG_H
#define QDIALOG_H

#include <gtkmm.h>

class QDialog : public Gtk::Dialog
{
public:
	typedef struct _CONFIG_
	{
		Gtk::Window *poParent;
		Glib::ustring stTitle;
		bool bWaitData;
		int iWidth;
	}
	tConfig;

	static void initConfig(tConfig& tConfigItem);
	
public:
	QDialog(const tConfig& tConfigItem);
	QDialog(BaseObjectType* cobject);
	
	~QDialog();

	void askData();

protected:
	inline Gtk::VBox* getVBox() {return gpoVBox;}
	
	virtual void on_response(int response_id);
	
private:
	Gtk::VBox* gpoVBox;
	bool gbWaitData;
};
	
#endif /* QDIALOG_H */
