/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef UTIL_H
#define UTIL_H

#include <gtkmm.h>
#include <vector>

class Util
{
public:
	Util();
	~Util();

	static const Glib::ustring compose(const char *format, ...);
	// base64
	static bool base64Dec(const Glib::ustring& st, Glib::ustring *pst64Dec);
	static bool base64Enc(const Glib::ustring& st, Glib::ustring *pst64Enc);
			
	// system exec
	static bool exec(   const Glib::ustring& stCmd,
						Glib::ustring *pstOutBuf = 0);
	static bool loadKernelModule(const Glib::ustring& stFilename);
	
	// file misc
	static bool getFileSize(const std::string& stFilename,
							unsigned long long *pullSize);
							
	// file content
	static bool file2string(const std::string& stFilename,
							Glib::ustring *pstData);
	static bool string2file(const Glib::ustring& stData,
							const std::string& stFilename);
	
	// file test
	static bool isDevice(   const Glib::ustring& stDevice, 
							Glib::ustring *pstErrMsg = 0);
	static bool isDirectory(const Glib::ustring& stDir, 
							Glib::ustring *pstErrMsg = 0);
	static bool isFileExist(const Glib::ustring& stFilename, 
							Glib::ustring *pstErrMsg = 0);
	static bool isRegularFile(  const Glib::ustring& stFilename, 
								Glib::ustring *pstErrMsg = 0);
	
	// other utilities	
	static bool getGroups(  std::vector<Glib::ustring>* pvecGroupName,
							std::vector<int>* pvecGroupID,
							Glib::ustring *pstErrMsg = 0);

	static bool getUsers(   std::vector<Glib::ustring>* pvecUserName,
							std::vector<int>* pvecUserID,
							Glib::ustring *pstErrMsg = 0);
	
	// sort
	static bool findSt( const Glib::ustring& st, 
						std::vector<Glib::ustring>& vec);
	static bool cmpst(  const Glib::ustring& st1, 
						const Glib::ustring& st2) {return (st1 < st2);}
};
	
#endif /* UTIL_H */
