/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VOLUMEDIALOG_H
#define VOLUMEDIALOG_H

#include "QDialog.h"
#include "Pline/MountData.h"

#include <gtkmm.h>

class DialogHelper;

class VolumeDialog : public QDialog
{
public:
	typedef struct _CONFIG_
	{
		bool bAutoRun;
		bool bWaitData;
		bool bAskPassword;
		bool bAskOverwrite;
		bool bOverwrite;
		bool bAskSelectDir;
		bool bCancelButton;
		bool bCancelButtonHasFocus;
		bool bYesNo;
		
		Glib::ustring stLabel;
		
		Glib::ustring stMsg;
		
		Glib::ustring stSrc;
		Glib::ustring stCommand;
		
		Glib::ustring stOverwriteData;
		Glib::ustring stSelectDirFieldName;
	}
	tConfig;
	
	static void initConfig(tConfig& tConfigItem);
	
public:
	VolumeDialog(const tConfig& tConfigItem);
	~VolumeDialog();

	const bool getOverwriteFlag();
	const Glib::ustring getOverwriteData();
	
	const Glib::ustring getPassword();
	
	const Glib::ustring getSelectDir();
	
	// used for permissions
	void setMountData(Pline::MountData *po) {gpoMountData = po;}
	
protected:

private:
	Gtk::Entry* gpoPasswdEntry;
	Gtk::Entry* gpoSaveAsEntry;
	Gtk::Entry* gpoSelectDirEntry;
	Gtk::CheckButton* gpoOverwriteCheckButton;
	Gtk::ToggleButton* gpoPermToggleButton;
	
	Pline::MountData* gpoMountData;
	
	static QDialog::tConfig getQDialogConfig(const tConfig& tConfigItem);

	void onBrowseSaveAs();
	void onBrowseSelectDir();
	void onPasswordActivate();
	void onPermissions();
};
	
#endif /* VOLUMEDIALOG_H */
