/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VOLUMEGUISTATE_H
#define VOLUMEGUISTATE_H

#include <gtkmm.h>

#include "VolumeCellRenderer.h"

class VolumeGuiState
{
public:
	VolumeGuiState();
	~VolumeGuiState();
	
	// label, pos, info
	inline const Glib::ustring& getInfo() {return gstInfo;}
	inline const Glib::ustring& getLabel() {return gstLabel;}
	inline const int getPos() {return giPos;}

	// set label and set for sorting
	inline void setLabel(const Glib::ustring& st) {gstLabel = st;}
	inline void setPos(const int i) {giPos = i;}
	
	// buttons state
	inline VolumeCellRenderer::eBtnState getBtnCancel() {return geBtnCancelState;}
	inline VolumeCellRenderer::eBtnState getBtnEject() {return geBtnEjectState;}
	inline VolumeCellRenderer::eBtnState getBtnMount() {return geBtnMountState;}
	
	// progress
	inline bool getISO() {return gbShowISO;}
	inline int getProgressPct() {return giProgressGaugePct;}
	inline int getUsedSpacePct() {return giProgressUsedSpacePct;}
	
	// get mode
	inline bool isEjectMode() {return gbEjectMode;}
	inline bool isMountMode() {return gbMountMode;}
	inline bool isProgressMode() {return gbProgressMode;}
	
	// set mode
	void setEjectMode(	const int iUsedSpacePct,
						const bool bISO,
						const Glib::ustring& stInfo = "");
	
	void setMountMode(const Glib::ustring& stInfo = "");
	
	void setProgressMode(   const int iProgressPct,
							const bool bCanCancel,
							const Glib::ustring& stInfo = "");
protected:

private:
	// buttons
	VolumeCellRenderer::eBtnState geBtnCancelState;
	VolumeCellRenderer::eBtnState geBtnEjectState;
	VolumeCellRenderer::eBtnState geBtnMountState;
	
	// text
	Glib::ustring   gstInfo;
	Glib::ustring   gstLabel;
	int				giPos;
	
	// progress
	bool	gbShowISO;
	int		giProgressGaugePct;
	int		giProgressUsedSpacePct;
	
	// mode
	bool gbEjectMode;
	bool gbMountMode;
	bool gbProgressMode;
};
	
#endif /* VOLUMEGUISTATE_H */
