/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * main.cc
 * Copyright (C) Aquei 2010 <aquei@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtkmm.h>
#include <glibmm/i18n.h>
#include <iostream>

#include "eMountSys.h"

//==============================================================================

int main (int argc, char *argv[])
{
	bool bRequireKit = false;
	int iRet = 0;
	
	if (!Glib::thread_supported()) Glib::thread_init();

	eMountSys::getInstance().init(argc, argv, &bRequireKit);
	
	if (bRequireKit)
	{
		Gtk::Main kit(argc, argv);
		
		iRet = eMountSys::getInstance().run(argc, argv, &kit);
		
		Glib::Error::register_cleanup();
		Glib::wrap_register_cleanup();
	}
	else
		iRet = eMountSys::getInstance().run(argc, argv);
	
	return iRet;
}

//==============================================================================
